'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.ColumnGroup = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('./utils/join');

var _join2 = _interopRequireDefault(_join);

var _reactLoadMask = require('react-load-mask');

var _reactLoadMask2 = _interopRequireDefault(_reactLoadMask);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

var _Body = require('./Body');

var _Body2 = _interopRequireDefault(_Body);

var _ColumnGroup = require('./Body/ColumnGroup');

var _ColumnGroup2 = _interopRequireDefault(_ColumnGroup);

require('react-load-mask/index.css');

var _Column = require('./Column');

var _Column2 = _interopRequireDefault(_Column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCREEN_HEIGHT = global.screen && global.screen.height;

var DataGrid = function (_Component) {
  _inherits(DataGrid, _Component);

  function DataGrid(props) {
    _classCallCheck(this, DataGrid);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DataGrid).call(this, props));

    _this.state = {
      loading: props.defaultLoading,
      data: false
    };
    return _this;
  }

  _createClass(DataGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var dataGridNode = (0, _reactDom.findDOMNode)(this.refs.dataGrid);

      // load data
      this.loadSourceData(this.props.dataSource, this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // if (nextProps.dataSource !== this.props.dataSource) {
      //   this.loadSourceData(nextProps.dataSource, nextProps)
      // }
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var dataSource = props.dataSource;
      var columns = props.columns;
      var hideHeader = props.hideHeader;
      var onRowHover = props.onRowHover;
      var onRowBlur = props.onRowBlur;
      var onScrollBottom = props.onScrollBottom;


      var className = (0, _join2.default)(props.className, 'react-datagrid');
      var loading = props.loading == undefined ? this.state.loading : props.loading;

      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({}, props, {
          column: true,
          flex: true,
          alignItems: 'stretch',
          className: className,
          ref: 'dataGrid'
        }),
        loading && this.renderLoadMask(),
        !hideHeader && _react2.default.createElement(_Header2.default, {
          columns: columns,
          columnGroups: props.children
        }),
        _react2.default.createElement(_Body2.default, _extends({}, props, {
          columns: columns,
          data: this.state.data,
          loading: loading,
          contentHeight: this.getContentHeight(),
          onRowHover: onRowHover,
          onRowBlur: onRowBlur,
          onScrollBottom: onScrollBottom
        }))
      );
    }
  }, {
    key: 'getContentHeight',
    value: function getContentHeight() {
      var rowHeight = this.props.rowHeight;
      var data = this.state.data;


      if (!data) {
        return 0;
      }

      var contentHeight = rowHeight * data.length;

      return contentHeight;
    }
  }, {
    key: 'renderLoadMask',
    value: function renderLoadMask() {
      return _react2.default.createElement(_reactLoadMask2.default, {
        visible: true,
        className: 'react-datagrid__load-mask'
      });
    }
  }, {
    key: 'loadSourceData',
    value: function loadSourceData(dataSource, props) {
      var _this2 = this;

      if (Array.isArray(dataSource)) {
        this.setState({
          data: dataSource,
          loading: false
        });
      }

      if (dataSource.then) {
        if (props.onDataSourceResponse) {
          dataSource.then(props.onDataSourceResponse, props.onDataSourceResponse);
        }

        this.setState({
          loading: true
        });

        dataSource.then(function (data) {

          if (!Array.isArray(data)) {
            throw new Error('dataSource Promise did not return an array, it returned a ' + (typeof data === 'undefined' ? 'undefined' : _typeof(data)));
          }

          _this2.setState({
            data: data,
            loading: false
          });
        }).catch(function (err) {
          console.error(err);
        });
      }
    }
  }]);

  return DataGrid;
}(_reactClass2.default);

DataGrid.defaultProps = {
  defaultLoading: true,
  hideHeader: false,
  onRowHover: function onRowHover() {},
  onRowBlur: function onRowBlur() {},
  onScrollBottom: function onScrollBottom() {}
};

DataGrid.propTypes = {
  loading: _react2.default.PropTypes.bool,
  idProperty: _react2.default.PropTypes.string.isRequired,

  columns: _react.PropTypes.arrayOf(function (props, propName) {
    var column = props[propName];

    if (!column.name && typeof column.render != 'function') {
      return new Error('column ' + propName + ' should have a "name" prop or a "render" function!');
    }
  }),

  dataSource: function dataSource(props, propName) {
    var dataSource = props[propName];

    if (!dataSource) {
      return new Error('dataSource prop is required.');
    }

    if (!(dataSource.then || Array.isArray(dataSource))) {
      return new Error('dataSource must be an array or a promise.');
    }
  },

  onDataSourceResponse: _react.PropTypes.func,
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumnGroup || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup and Column');
      }
    });
  },

  onScroll: _react.PropTypes.func,
  hideHeader: _react.PropTypes.bool,
  onRowHover: _react.PropTypes.func,
  onRowBlur: _react.PropTypes.func,
  onScrollBottom: _react.PropTypes.func
};

exports.default = DataGrid;

// Column is a dummy componnet only used for configuration

exports.ColumnGroup = _ColumnGroup2.default;
exports.Column = _Column2.default;